=== debian/changelog ===
xgboost (2.0.2-2) unstable; urgency=medium

  * Properly clean built binaries. (Closes: #1049063)
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 17 Dec 2023 20:07:51 -0500

xgboost (2.0.2-1) experimental; urgency=medium

  * New upstream version 2.0.2 (Nov 2023)
  * Rebase existing patches; remove deprecated ones.
  * Change python build from setup.py to pyproject.
  * Suggests python3-sklearn for the python package.
  * Use upstream python demo for autopkgtest directly.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Dec 2023 15:15:41 -0500
