=== doc/requirements.txt ===
sphinx
mock
sphinx_rtd_theme>=1.0.0
breathe
scikit-learn
sh
matplotlib
graphviz
numpy
myst-parser
xgboost_ray
sphinx-gallery
pyspark
cloudpickle
setuptools
