=== debian/changelog ===
xgboost (2.0.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:47:23 +1100

xgboost (2.0.3-1build1) noble; urgency=medium

  * Rebuild against latest dmlc-core

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 06 Mar 2024 19:45:31 -0500

xgboost (2.0.3-1) unstable; urgency=medium

  * New upstream version 2.0.3

 -- Mo Zhou <lumin@debian.org>  Fri, 29 Dec 2023 14:37:55 -0500
