=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Standards-Version: 4.6.0.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/xgboost.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/xgboost
-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Rules-Requires-Root: no
 Build-Depends: cmake,
