=== debian/tests/control ===
Test-Command: python3 demo/guide-python/basic_walkthrough.py
Depends: @, python3-sklearn, python3-scipy
Restrictions: allow-stderr
