=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%xgboost-$1.tar.gz%" \
https://github.com/dmlc/xgboost/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
